// main.js - Spur Z Room Trains Gallery widget
// 2006 nakajima@netstock.co.jp
include("deEntity.js");

const HOMEURL = "http://spur-z-room.com/";
const GalleryURL = "http://spur-z-room.com/modules/xoopsgallery/albums.php";

var BigPhotoWindow;
var BigPhotoImage;

var PhotoWidth = 0;
var PhotoHeight = 0;

var Mapchange2 = -1;
var WithPhoto = 1;
var Articles;
var ArticleIndex = 0;
var MesMenuItems = new Array();

var Description = "";
var Description2 = "";
var Message = "";
var Mescolor = "#000000";

function getText(sData, sStartMarker, sEndMarker, iStartIndex)
{
	var iStart;
	var iEnd;
	if( sStartMarker == "" ) {
		iStart = iStartIndex;
		iEnd   = sData.indexOf(sEndMarker, iStart);
	} else {
		iStart = sData.indexOf(sStartMarker, iStartIndex);
		iEnd   = sData.indexOf(sEndMarker, iStart+sStartMarker.length);
	}
	if ((iStart < 0)||(iEnd < 0)||(iStart >= iEnd)) {
		return "";
	} else {
		return sData.substring(iStart+sStartMarker.length, iEnd);
	}
}

function Trim(sText)
{
	return sText.replace(/^\s+/g, "").replace(/\s+$/g, "");;
}

function OnUnLoad()
{
	preferences.bottompos.value = mainwindow.vOffset + mainwindow.height;
}

function initWidget()
{
	if( preferences.adjustbottom.value == 1 ) {
		mainwindow.vOffset = preferences.bottompos.value - mainwindow.height;
		if( mainwindow.vOffset < 0 ) {
			mainwindow.vOffset = 0;
		}
	}

	help.tooltip = "Title text click: Show message\nRight frame click: Next photo\nLeft frame click: Previous photo\nTop frame click: First photo\nBottom frame click: Last photo\nPhoto double click: Show big photo\nRight mouse button click: Configuration, Exit,...";

//	Update timer
	changetimer.interval = preferences.changerate.value;
	refreshtimer.interval = preferences.refreshrate.value;

//	make window and image for big photo
	var sw = screen.availWidth;
	var sh = screen.availHeight;
	BigPhotoWindow = new Window();
	BigPhotoWindow.visible = false;
	BigPhotoWindow.name = "bigphotowindow";
	BigPhotoWindow.width = sw;
	BigPhotoWindow.height = sh;
	BigPhotoWindow.hOffset = 0;
	BigPhotoWindow.vOffset = 0;
	BigPhotoWindow.alignment = "left";
	BigPhotoImage = new Image(BigPhotoWindow);
	BigPhotoImage.name = "bigphoto";
	BigPhotoImage.onMouseUp = "hideBigPhotoWindow();";

}

function showBigPhotoWindow()
{
	BigPhotoWindow.visible = true;
}

function hideBigPhotoWindow()
{
	BigPhotoWindow.visible = false;
	mainwindow.focus();
}

function Article(main, sub, url, text, date)
{
	this.main = main;
	this.sub = sub;
	this.url = url;
	this.text = text;
	this.date = date;
}

Article.prototype.fetch = function() {
	fetchPhoto(this.url);
}

function fetchAlbums() {
	Articles = new Array();
	
	var objURL = new URL();
	objURL.location = GalleryURL;
	var urldata = objURL.fetch();
	if (urldata.length == 0 || urldata == "Could not load URL") {
		return "";
	}
	var sHTML = objURL.result;
	//filesystem.writeFile("a.html", sHTML);
	var albumre = RegExp("set_albumName=album([0-9]+)\">(.+?)</a></?([a-z]+)", "g");
	var result;
	var main, sub;
	while( result = albumre.exec(sHTML) ) {
		var num = result[1];
		var name = result[2];
		var divbr = result[3];
		if( divbr == "div" ) { // main album
			main = name;
		} else if( divbr == "br" ) { // sub album
			sub = name;
			fetchAlbum(main, sub, num);
		}
	}

	MakeMesMenuItems();
}

function fetchAlbum(main, sub, num, page) {
	//alert(main + ", " + sub + ", " + num);
	var desc = "Loading [" + main + "/" + sub + "]";
	resumeUpdates();
	comments.data = desc;
	commentsshadow.data = desc;
	suppressUpdates();
	
	var objURL = new URL();
	var url = "http://spur-z-room.com/modules/xoopsgallery/view_album.php?set_albumName=album" + num;
	if( page ) {
		url += "?page=" + page;
	}
	objURL.location = url;
	var urldata = objURL.fetch();
	if (urldata.length == 0 || urldata == "Could not load URL") {
		return "";
	}
	var sHTML = objURL.result;
	//filesystem.writeFile("sa.html", sHTML);
	
	var lastpage = 0;
	if( !page ) {
		var pagere = RegExp("set_albumName=album" + num + "&page=([0-9]+)\"", "g");
		var result;
		while( result = pagere.exec(sHTML) ) {
			lastpage = result[1];
		}
	}
	
	var grid = 
		getText(sHTML, "<!-- image grid table -->", "<!-- bottom nav -->", 0);
	var infore = RegExp("/album" + num + "/(.+?)\.thumb\.jpg|<b>((?:.|\r|\n)+?)</b>|最終更新</td><td nowrap class=\"even\">([0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2})<", "g");
	var urlnum = Articles.length;
	var textnum = Articles.length;
	var datenum = Articles.length;
	var result;
	while( result = infore.exec(grid) ) {
		//print(result + "\r\n");
		if( result[1] ) {
			var url = "http://spur-z-room.com/modules/xoopsgallery/cache/albums/album" + num + "/" + result[1] + ".jpg";
			//print(url + "\r\n");
			Articles[urlnum] = new Article(main, sub, url, "", "");
			urlnum++;
		} else if( result[2] ) {
			if( textnum >= Articles.length ) {
				alert("Internal Error: textnum overrun");
			} else {
				var text = result[2];
				text = text.replace(/<br *\/?>/ig, "\n");
				Articles[textnum].text = text;
				textnum++;
			}
		} else if( result[3] ) {
			if( datenum >= Articles.length ) {
				alert("Internal Error: datenum overrun");
			} else {
				Articles[datenum].date = result[3];
				datenum++;
			}
		}
	}
	
	// fetch 2 .. lastpage
	for( var j = 2; j <= lastpage; j++ ) {
		fetchAlbum(main, sub, num, j);
	}
}

function setArticle()
{
	if( Articles.length == 0 ) {
		comments.data = "No article found";
		commentsshadow.data = "No article found";
		return;
	}
	
	var ai = ArticleIndex;
	if( ai > Articles.length - 1 ) {
		alert("Internal error: article index overrun");
		return;
	}
	
	var article = Articles[ai];

	Description2 = article.text;
	Description = "[" + article.main + "/" + article.sub + "] " + article.date;
	Message = article.text;
	//Mescolor = smescolor;

	var limage = fetchPhoto(article.url);
	if (limage == "Could not load URL") {	
		return "";
	}
	
	status.data = Description2;
	comments.data = Description;
	statusshadow.data = Description2;
	commentsshadow.data = Description;
}

function fetchPhoto(url)
{
	var objURL = new URL();
	objURL.outputFile = "resources/cache/image.jpg";
	objURL.location = url;
	var limage = objURL.fetch();
	if (limage == "Could not load URL") {	
		comments.data = "Connection error, using cached picture";
		commentsshadow.data = "Connection error, using cached picture";
	}
	return limage;
}

function loadImage()
{
	//fetchArticles();
	fetchAlbums();
	if( preferences.changemethod.value == "sequence" ) {
		ArticleIndex = 0;
	} else {
		ArticleIndex = Math.floor(Math.random() * Articles.length);
	}
	setArticle();
}

function adjustSize(w, h)
{
	if( PhotoWidth != w || PhotoHeight != h ) {
		PhotoWidth = w;
		PhotoHeight = h;
		var statussize = 14;
		var commentssize = 10;
		if (w <= 140) {
			statussize = 10;
		} else if (w <= 200) {
			statussize = 12;
		}
		status.size=statussize;
		statusshadow.size=statussize;
		comments.size=commentssize;
		commentsshadow.size=commentssize;
		var titlesize = statussize + commentssize;

		status.hOffset=0;
		status.vOffset=statussize;
		status.color = preferences.titlecolor.value;
		comments.hOffset=0;
		comments.vOffset=titlesize;
		comments.color = preferences.titlecolor.value;
		statusshadow.hOffset=1;
		statusshadow.vOffset=statussize+1;
		statusshadow.color = 0;
		commentsshadow.hOffset=1;
		commentsshadow.vOffset=titlesize+1;
		commentsshadow.color = 0;

		titlesize += 2;
		var prevheight = mainwindow.height;
		mainwindow.width  = w + 30;
		mainwindow.height = h + titlesize + 20;
		if( preferences.adjustbottom.value == 1 ) {
			mainwindow.vOffset += prevheight - mainwindow.height;
			if( mainwindow.vOffset < 0 ) {
				mainwindow.vOffset = 0;
			}
		}
		photo.vOffset = titlesize + 10;
		for (i = 1; i < 4; i++) {
			eval("frame_"+i+"2.width=w;");
			eval("frame_1"+i+".vOffset=titlesize;");
			eval("frame_2"+i+".height=h;");
			eval("frame_2"+i+".vOffset=titlesize+10;");
			eval("frame_"+i+"3.hOffset=w+10;");
			eval("frame_3"+i+".vOffset=h+titlesize+10;");
		}
		help.hOffset = w;
		helpshadow.hOffset = w + 2;
		help.vOffset = titlesize - 2;
		helpshadow.vOffset = titlesize;
	}
	photo.width  = w;
	photo.height = h;
}

function drawImage()
{

	photo.src = "";
	if( WithPhoto > 0 ) {
		photo.src = "resources/cache/image.jpg";
		photo.opacity = 255;
		if( photo.srcWidth == 0 || photo.srcHeight == 0 ) {
			photo.src = "resources/images/nophoto.png";
			photo.opacity = 128;
		}
	} else {
		photo.src = "resources/images/nophoto.png";
		photo.opacity = 128;
	}

//	Source width and height
	wsrc = photo.srcWidth;
	hsrc = photo.srcHeight;

//	Destination width and height (check for aspect ratio preference)
	w = Math.round(preferences.imagewidth.value);
	h = Math.round(w * hsrc/wsrc);
	
//	Set frame, photo, help and title sizes and positions
	adjustSize(w, h);

//	Colorize frame
	gsFrameColor = preferences.framecolor.value;
	for (i = 1; i < 4; i++) {
		for (j = 1; j < 4; j++) {
			eval("frame_"+i+""+j+".colorize=gsFrameColor;");
		}
	}

//	Display image info
	if (preferences.showtooltip.value==1){
		photo.tooltip = Message;
	} else {
		photo.tooltip = "";
	}
}

function refreshArticle()
{
	suppressUpdates();
	setArticle();
	drawImage();
	setMessage();
	setBigPhoto();
	resumeUpdates();
}

function refreshPhoto()
{
	suppressUpdates();
	fetchPhoto(Articles[ArticleIndex].url);
	drawImage();
	setBigPhoto();
	resumeUpdates();
}

function nextArticle()
{
	if( ArticleIndex < Articles.length - 1 ) {
		ArticleIndex++;
	} else {
		ArticleIndex = 0;
	}
	refreshArticle();
}

function prevArticle()
{
	if( ArticleIndex > 0 ) {
		ArticleIndex--;
	} else {
		ArticleIndex = Articles.length - 1;
	}
	refreshArticle();
}

function firstArticle()
{
	ArticleIndex = 0;
	refreshArticle();
}

function lastArticle()
{
	ArticleIndex = Articles.length - 1;
	refreshArticle();
}

function SelectArticle(num)
{
	ArticleIndex = num;
	refreshArticle();
}

function updatePreferences()
{
	hideBigPhotoWindow();
	hideMessageWindow();
	//refreshDisplay();
	drawImage();

	if (Mapchange2 != preferences.showshadow.value)
	{	Mapchange2 = preferences.showshadow.value;
		if (preferences.showshadow.value == 0)
		{	statusshadow.opacity=0; 		
			commentsshadow.opacity=0;	}
		else
		{	statusshadow.opacity=255; 		
			commentsshadow.opacity=255;	}
	}
	if (changetimer.interval != preferences.changerate.value){
		changetimer.ticking = 0;
		changetimer.interval = preferences.changerate.value;
		changetimer.ticking = 1;
	}
	if (refreshtimer.interval != preferences.refreshrate.value){
		refreshtimer.ticking = 0;
		refreshtimer.interval = preferences.refreshrate.value;
		refreshtimer.ticking = 1;
	}

}

function changeArticle()
{
	changetimer.ticking = 0;
	refreshtimer.ticking = 0;
	if( preferences.changemethod.value == "sequence" ) {
		nextArticle();
	} else { // random
		ArticleIndex = Math.floor(Math.random() * Articles.length);
		refreshArticle();
	}
	refreshtimer.ticking = 1;
	changetimer.ticking = 1;
}

function refreshDisplay()
{
	changetimer.ticking = 0;
	refreshtimer.ticking = 0;
	comments.data = "Checking website...";
	commentsshadow.data = "Checking website...";
	updateNow();
	suppressUpdates();	
	loadImage();
	drawImage();
	resumeUpdates();
	refreshtimer.ticking = 1;
	changetimer.ticking = 1;
}

function setBigPhoto()
{
	BigPhotoImage.src = "";
	if( WithPhoto > 0 ) {
		BigPhotoImage.src = "resources/cache/image.jpg";
	} else {
		BigPhotoImage.src = "resources/images/nophoto.jpg";
	}
	var ow = BigPhotoImage.srcWidth;
	var oh = BigPhotoImage.srcHeight;
	var ww = BigPhotoWindow.width - 100;
	var wh = BigPhotoWindow.height - 100;
	if( ow <= ww && oh <= wh ) {
		BigPhotoImage.width = ow;
		BigPhotoImage.height = oh;
	} else {
		var orate = oh / ow;
		var wrate = wh / ww;
		if( orate > wrate ) {
			BigPhotoImage.width = wh / orate;
			BigPhotoImage.height = wh;
		} else {
			BigPhotoImage.width = ww;
			BigPhotoImage.height = ww * orate;
		}
	}
	BigPhotoImage.hOffset = (BigPhotoWindow.width - BigPhotoImage.width) / 2;
	BigPhotoImage.vOffset = (BigPhotoWindow.height - BigPhotoImage.height) / 2;
}

function showBigPhoto()
{
	if( BigPhotoWindow.visible ) {
		hideBigPhotoWindow();
		return;
	}
	setBigPhoto();
	showBigPhotoWindow();
}

function showHomePage()
{
	if (HOMEURL != "") {
		openURL(HOMEURL);
	}
}

function showGalleryPage()
{
	if (GalleryURL != "") {
		openURL(GalleryURL);
	}
}

function showHelpMark()
{
	helpshadow.visible = true;
	help.visible = true;
}

function hideHelpMark()
{
	helpshadow.visible = false;
	help.visible = false;
}

function showMessageWindow()
{
	messagewindow.visible = true;
}

function hideMessageWindow()
{
	messagewindow.visible = false;
	mainwindow.focus();
}

function setMessage()
{
	messagearea.data = Description + "\n\n" + Message;
	//messagearea.color = Mescolor;
	messagearea.editable = true;
	messagearea.select(0,0);
	messagearea.focus();
	messagearea.editable = false;
}

function showMessage()
{
	if( messagewindow.visible ) {
		hideMessageWindow();
		return;
	}
	setMessage();
	messagewindow.hOffset = mainwindow.hOffset + mainwindow.width;
	if( messagewindow.hOffset + messagewindow.width > screen.availWidth ) {
		messagewindow.hOffset = mainwindow.hOffset - 10 - messagewindow.width;
	}
	messagewindow.vOffset = mainwindow.vOffset;
	if( messagewindow.vOffset + messagewindow.height > screen.availHeight ) {
		messagewindow.vOffset -= 
			messagewindow.vOffset + messagewindow.height - screen.availHeight;
	}
	showMessageWindow();
}

function ClearMesMenuItems()
{
	for( j = 0; j < MesMenuItems.length; j++ ) {
		delete MesMenuItems[j];
	}
	MesMenuItems = new Array();
}

function AddMesMenuItems(title, enabled, checked, onselect)
{
	var item = new MenuItem();
	item.title = title;
	item.enabled = enabled;
	item.checked = checked;
	item.onSelect = onselect;
	MesMenuItems.push(item);
}

function MakeMesMenuItems()
{
	ClearMesMenuItems();
	var lastmainsub = "";
	for( j = 0; j < Articles.length; j++ ) {
		var article = Articles[j];
		var mainsub = article.main + "/" + article.sub;
		if( mainsub != lastmainsub ) {
			var title = mainsub;
			var enabled = true;
			var checked = false;
			var onselect = "SelectArticle(" + j + ");";
			AddMesMenuItems(title, enabled, checked, onselect);
			lastmainsub = mainsub;
		}
	}
}

function commentsMessageMenu()
{
	comments.contextMenuItems = MesMenuItems;
}

function statusMessageMenu()
{
	status.contextMenuItems = MesMenuItems;
}

function setMainWindowOpacity(op)
{
	mainwindow.opacity = op;
}

function onGainFocus()
{
	if( BigPhotoWindow.visible ) {
		BigPhotoWindow.focus();
	}
	if( messagewindow.visible ) {
		messagewindow.focus();
	}
	showHelpMark();
	if( preferences.transparent.value == 1 ) {
		setMainWindowOpacity(255);
	}
}

function onLoseFocus()
{
	if( !BigPhotoWindow.visible && !messagewindow.visible ) {
		hideHelpMark();
		if( preferences.transparent.value == 1 ) {
			setMainWindowOpacity(128);
		}
	}
}

suppressUpdates();
initWidget();
Mapchange2 = preferences.showshadow.value;
if (preferences.showshadow.value == 0) {
	statusshadow.opacity=0;
	commentsshadow.opacity=0;
} else {
	statusshadow.opacity=255;
	commentsshadow.opacity=255;
}
loadImage();
frame_22.opacity = 0;
drawImage();
resumeUpdates();
mainwindow.focus();
